Arch Space: Difference between revisions

From FreeCAD Documentation
(adding <translate>)
No edit summary
(39 intermediate revisions by 6 users not shown)
Line 1: Line 1:
<languages/>
<translate>
<translate>
<!--T:22-->
{{GuiCommand|Name=Arch_Space|Workbenches=[[Arch Module|Arch]]|MenuLocation=Arch → Space|Shortcut=S P}}
{{Docnav
|[[Arch_Roof|Roof]]
|[[Arch_Stairs|Stairs]]
|[[Arch_Module|Arch]]
|IconL=Arch_Roof.svg
|IconR=Arch_Stairs.svg
|IconC=Workbench_Arch.svg
}}


<!--T:1-->
==Description==
{{GuiCommand
Basically it is a solid shape (but represented as "empty") that can be defined either
|Name=Arch Space
# by an underlying solid shape object or
|MenuLocation=Arch → Space
# by a set of boundary faces from other objects. In that case, the space volume is defined by taking the bounding box of all the faces, then removing exterior parts behind the boundary faces.
|Workbenches=[[Arch_Module|Arch]]
|Shortcut={{KEY|S}} {{KEY|P}}
|Version=0.14
|SeeAlso=[[Arch_Wall|Arch Wall]], [[Arch_Structure|Arch Structure]]
}}


==Description== <!--T:2-->
New boundary faces can be added later with the Arch Add button, even to spaces created from a solid. Existing boundaries can be removed with the Arch Remove button.
The Space tool allows you to define an empty volume, either by basing it on a solid shape, or by defining its boundaries, or a mix of both. If it is based solely on boundaries, the volume is calculated by starting from the bounding box of all the given boundaries, and subtracting the spaces behind each boundary. The space object always defines a solid volume. The floor area of a space object, calculated by intersecting a horizontal plane at the center of mass of the space volume, can also be displayed.


Finally, the space uses the new "detailed" display mode (that will in the future be used by all Arch objects) to show the area, taken from a horizontal section plane that cuts the space at its center.
</translate>
</translate>
[[Image:Arch Space example.jpg|640px]]
<translate>
<!--T:3-->
{{Caption|Space object created from an existing solid object, then two wall faces are added as boundaries.}}


==Usage== <!--T:5-->
[[File:Space_it.png|left]]

{{clear}}
<!--T:6-->
# Select an existing solid object, or faces on boundary objects.
# Invoke the Arch Space command using several methods:
#* Pressing the {{Button|[[Image:Arch_Space.svg|16px]] [[Arch Space]]}} button in the toolbar.
#* Using the {{KEY|S}} then {{KEY|P}} keyboard keys
#* Using the {{MenuCommand|Arch → Space}} entry from the top menu

=== Limitations === <!--T:13-->

<!--T:20-->
* The boundaries properties is currently not editable via GUI.
* See the [http://forum.freecadweb.org/viewtopic.php?f=9&t=4275 forum announcement].

==Properties== <!--T:7-->

<!--T:8-->
* {{PropertyData|Base}}: The base object, if any (must be a solid)
* {{PropertyData|Boundaries}}: A list of optional boundary elements
* {{PropertyData|Area}}: The computed floor area of this space
* {{PropertyData|FinishFloor}}: The finishing of the floor of this space
* {{PropertyData|FinishWalls}}: The finishing of the walls of this space
* {{PropertyData|FinishCeiling}}: The finishing of the ceiling of this space
* {{PropertyData|Group}}: Objects that are included inside this space, such as furniture
* {{PropertyData|SpaceType}}: The type of this space
* {{PropertyData|FloorThickness}}: The thickness of the floor finish
* {{PropertyData|NumberOfPeople}}: The number of people who typically occupy this space
* {{PropertyData|LightingPower}}: The electric power needed to light this space in Watts
* {{PropertyData|EquipmentPower}}: The electric power needed by the equipment of this space in Watts
* {{PropertyData|AutoPower}}: If True, Equipment Power will be automatically filled by the equipment included in this space
* {{PropertyData|Conditioning}}: The type of air conditioning of this space
* {{PropertyData|Internal}}: Specifies if this space is internal or external

<!--T:25-->
* {{PropertyView|Text}}: The text to show. Use $area, $label, $tag, $floor, $walls, $ceiling to insert the respective data
* {{PropertyView|FontName}}: The name of the font
* {{PropertyView|TextColor}}: The color of the text
* {{PropertyView|FontSize}}: The size of the text
* {{PropertyView|FirstLine}}: The size of the first line of text (multiplies the font size. 1 = same size, 2 = double size, etc..)
* {{PropertyView|LineSpacing}}: The space between the lines of text
* {{PropertyView|TextPosition}}: The position of the text. Leave (0,0,0) for automatic position
* {{PropertyView|TextAlign}}: The justification of the text
* {{PropertyView|Decimals}}: The number of decimals to use for calculated texts
* {{PropertyView|ShowUnit}}: Show the unit suffix or not

==Options== <!--T:26-->

<!--T:27-->
* To create zones that group several spaces, use a [[Arch BuildingPart]] and set its IFC type to "Spatial Zone"
* The space object has the same display modes as other Arch and Part objects, with one more, called '''Footprint''', that displays only the bottom face of the space. {{Version|0.19}}

==Scripting== <!--T:14-->
{{Emphasis|See also:}} [[Arch API]] and [[FreeCAD Scripting Basics]].

<!--T:15-->
The Space tool can be used in [[macros]] and from the [[Python]] console by using the following function:
</translate>
{{Code|code=
Space = makeSpace(objects=None, baseobj=None, name="Space")
}}
<translate>
<translate>
==How to use==


<!--T:16-->
* Select faces or objects
* Press the {{KEY|[[Image:Arch_Space.png|32px]] Space}} button, or press {{KEY|S}}, {{KEY|P}} keys
* Creates a {{incode|Space}} object from the given {{incode|objects}} or {{incode|baseobj}}, which can be
** one document object, in which case it becomes the base shape of the space object, or
** a list of selection objects as returned by {{incode|FreeCADGui.Selection.getSelectionEx()}}, or
** a list of tuples {{incode|(object, subobjectname)}}


<!--T:17-->
==Properties==
Example:
</translate>
{{Code|code=
import FreeCAD, Arch


Box = FreeCAD.ActiveDocument.addObject("Part::Box", "Box")
[[File:SpaceProperties_it.png|left]]
Box.Length = 1000
Box.Width = 1000
Box.Height = 1000


Space = Arch.makeSpace(Box)
===Data===
Space.ViewObject.LineWidth = 2
FreeCAD.ActiveDocument.recompute()
}}
<translate>


<!--T:18-->
====Arch====
After a space object is created, selected faces can be added to it with the following code:
</translate>
{{Code|code=
import FreeCAD, FreeCADGui, Draft, Arch


points = [FreeCAD.Vector(-500, 0, 0), FreeCAD.Vector(1000, 1000, 0)]
* {{PropertyData|Base}}
Line = Draft.makeWire(points)
Wall = Arch.makeWall(Line, width=150, height=2000)
FreeCAD.ActiveDocument.recompute()


# Select a face of the wall
====Base====
selection = FreeCADGui.Selection.getSelectionEx()
* {{PropertyData|Label}}
Arch.addSpaceBoundaries(Space, selection)
* {{PropertyData|Placement}}
}}
** {{PropertyData|Angle}}
<translate>
** {{PropertyData|Axis}}
** {{PropertyData|Position}}


<!--T:19-->
{{clear}}
Boundaries can also be removed, again by selecting the indicated faces:
==Limitation==
* See [http://forum.freecadweb.org/viewtopic.php?f=9&t=4275 Arch Space] .
</translate>
</translate>
{{Code|code=
<languages/>
selection = FreeCADGui.Selection.getSelectionEx()
Arch.removeSpaceBoundaries(Space, selection)
}}

<translate>
<!--T:21-->
{{Docnav
|[[Arch_Roof|Roof]]
|[[Arch_Stairs|Stairs]]
|[[Arch_Module|Arch]]
|IconL=Arch_Roof.svg
|IconR=Arch_Stairs.svg
|IconC=Workbench_Arch.svg
}}

</translate>
{{Arch Tools navi{{#translation:}}}}

{{Userdocnavi{{#translation:}}}}

Revision as of 14:21, 29 November 2020

Arch Space

Menu location
Arch → Space
Workbenches
Arch
Default shortcut
S P
Introduced in version
0.14
See also
Arch Wall, Arch Structure

Description

The Space tool allows you to define an empty volume, either by basing it on a solid shape, or by defining its boundaries, or a mix of both. If it is based solely on boundaries, the volume is calculated by starting from the bounding box of all the given boundaries, and subtracting the spaces behind each boundary. The space object always defines a solid volume. The floor area of a space object, calculated by intersecting a horizontal plane at the center of mass of the space volume, can also be displayed.

Space object created from an existing solid object, then two wall faces are added as boundaries.

Usage

  1. Select an existing solid object, or faces on boundary objects.
  2. Invoke the Arch Space command using several methods:
    • Pressing the Arch Space button in the toolbar.
    • Using the S then P keyboard keys
    • Using the Arch → Space entry from the top menu

Limitations

Properties

  • DataBase: The base object, if any (must be a solid)
  • DataBoundaries: A list of optional boundary elements
  • DataArea: The computed floor area of this space
  • DataFinishFloor: The finishing of the floor of this space
  • DataFinishWalls: The finishing of the walls of this space
  • DataFinishCeiling: The finishing of the ceiling of this space
  • DataGroup: Objects that are included inside this space, such as furniture
  • DataSpaceType: The type of this space
  • DataFloorThickness: The thickness of the floor finish
  • DataNumberOfPeople: The number of people who typically occupy this space
  • DataLightingPower: The electric power needed to light this space in Watts
  • DataEquipmentPower: The electric power needed by the equipment of this space in Watts
  • DataAutoPower: If True, Equipment Power will be automatically filled by the equipment included in this space
  • DataConditioning: The type of air conditioning of this space
  • DataInternal: Specifies if this space is internal or external
  • ViewText: The text to show. Use $area, $label, $tag, $floor, $walls, $ceiling to insert the respective data
  • ViewFontName: The name of the font
  • ViewTextColor: The color of the text
  • ViewFontSize: The size of the text
  • ViewFirstLine: The size of the first line of text (multiplies the font size. 1 = same size, 2 = double size, etc..)
  • ViewLineSpacing: The space between the lines of text
  • ViewTextPosition: The position of the text. Leave (0,0,0) for automatic position
  • ViewTextAlign: The justification of the text
  • ViewDecimals: The number of decimals to use for calculated texts
  • ViewShowUnit: Show the unit suffix or not

Options

  • To create zones that group several spaces, use a Arch BuildingPart and set its IFC type to "Spatial Zone"
  • The space object has the same display modes as other Arch and Part objects, with one more, called Footprint, that displays only the bottom face of the space. introduced in version 0.19

Scripting

See also: Arch API and FreeCAD Scripting Basics.

The Space tool can be used in macros and from the Python console by using the following function:

Space = makeSpace(objects=None, baseobj=None, name="Space")
  • Creates a Space object from the given objects or baseobj, which can be
    • one document object, in which case it becomes the base shape of the space object, or
    • a list of selection objects as returned by FreeCADGui.Selection.getSelectionEx(), or
    • a list of tuples (object, subobjectname)

Example:

import FreeCAD, Arch

Box = FreeCAD.ActiveDocument.addObject("Part::Box", "Box")
Box.Length = 1000
Box.Width = 1000
Box.Height = 1000

Space = Arch.makeSpace(Box)
Space.ViewObject.LineWidth = 2
FreeCAD.ActiveDocument.recompute()

After a space object is created, selected faces can be added to it with the following code:

import FreeCAD, FreeCADGui, Draft, Arch

points = [FreeCAD.Vector(-500, 0, 0), FreeCAD.Vector(1000, 1000, 0)]
Line = Draft.makeWire(points)
Wall = Arch.makeWall(Line, width=150, height=2000)
FreeCAD.ActiveDocument.recompute()

# Select a face of the wall
selection = FreeCADGui.Selection.getSelectionEx()
Arch.addSpaceBoundaries(Space, selection)

Boundaries can also be removed, again by selecting the indicated faces:

selection = FreeCADGui.Selection.getSelectionEx()
Arch.removeSpaceBoundaries(Space, selection)